<?php

    include_once("class/database.php");
    include_once("class/category.php");

    function update(&$database)
    {
        $sql = array();
        $log = array();
        
        $log[] = "Update wird gestartet...";
    
        // Datenbank an neue Struktur anpassen
        $sql[] = "CREATE TABLE internal (keyName CHAR(30) CHARACTER SET ASCII UNIQUE NOT NULL, keyValue CHAR(30));";
        $sql[] = "INSERT INTO internal SET keyName='dbVersion', keyValue='0';";
        $sql[] = "ALTER TABLE  `storeloc` ADD  `parentnode` int(11) NOT NULL default '0' AFTER  `name` ;";
        $sql[] = "ALTER TABLE  `storeloc` ADD  `is_full` boolean NOT NULL default false AFTER `parentnode` ;";
        
        foreach ($sql as $query)
        {
            if (! $database->execute($query))
            {
                $log[] = "Fehler beim Ausführen des SQL-Befehls: $query";
                $log[] = "Update abgebrochen. Bitte Fehler überprüfen.";
                return;
            }
            else
            {
                $log[] = "SQL: $query....OK!";
            }
        }
        
        $log[] = "Die Datenbank wurde erfolgreich an die neue Struktur angepasst.";
        
        // Alle doppelten Kategorien holen
        $log[] = "Suche nach doppelten Kategorien...";
        $same_named_categories = array();
        $root_category = new Category($database, 0);
        $all_categories = $root_category->get_subelements(true);
        
        foreach ($all_categories as $category)
        {
            $parent = new Category($database, $category->get_parent_id());
            $same_level_categories = $parent->get_subelements(false);
            foreach ($same_level_categories as $cat2)
            {
                if ($cat2->get_name() == $category->get_name())
                {
                    $log[] = "Doppelt vorhandene Kategorie gefunden: ".$category->get_full_name();
                    $same_named_categories[] = $category;
                }
            }
        }
        
        if (count($same_named_categories) > 0)
        {
            $log[] = "Öffne Popup zum umbenennen der doppelten Kategorien";
            // Hier könnte man ein Popup öffnen, in dem alle gleichnamigen Kategorien
            // aufgelistet und umbenannt werden können.
            
            if (popup == success)
            {
                $log[] = "Kategorien erfolgreich umbenannt";
            }
            else
            {
                $log[] = "Umbenennen wurde abgebrochen. Das Update wird nicht fortgesetzt.";
                return:
            }
        }
        else
            $log[] = "Keine doppelten Kategorien vorhanden";
        
        // Und hier vielleicht noch ein paar Dateioperationen durchführen...
        unlink("open/openlist.php");
        copy("lib.php", "lib_alt.php");
        rename("fpmgr.php", "fpmgr2.php");
        
        $log[] = "Update erfolgreich durchgeführt";
        
        return $log;
    }
    
    function backup()
    {
        // Hier könnte man noch selber irgend ein Backup durchführen
        // Alle Dateien, die sich im files/ Ordner befinden, werden aber
        // schon vom System gesichert und müssen hier nicht behandelt werden.
        
        // Da wir im Update aber noch Dateien löschen und umbenennen,
        // müssen wir dem System noch mitteilen, dass diese zwei Dateien
        // noch mitgesichert werden sollen:
        return array("open/openlist.php", "fpmgr.php");
    }
    
    function restore()
    {
        // Hier könnte man selber ein Restore durchführen,
        // das individuell auf dieses Update angepasst ist.
        // Die Systemdateien werden natürlich vom System selber wieder
        // hergestellt und müssen hier nicht behandelt werden.
        
        // Da wir aber im Update eine neue Datei angelegt haben. 
        // und eine umbenannt haben, können wir die nun wieder löschen:
        unlink("lib_alt.php");
        unlink("fpmgr2.php");
    }
    
